/* ------------------------------------------------
   Action du mineur */

   %  action(Map, PosMineur, CanGotoExit, Mouvement)

% Le mineur ralise une action prdfinie
action(Map, PosMineur, CanGotoExit, Mouvement)
:- recorded(performingAction, true),                              % /SI\ Une action est en cours
   recorded(currentAction, Action),                               % On rcupre le script de l'action
   doAction(Action, Map, PosMineur, CanGotoExit, Mouvement), !.   % On execute le prochain pas de l'action
   
% un chemin est en cours
action(NavMap, PosMineur, CanGotoExit, Mouvement)
:- recorded(way, [ToGo | Way]),
   save(way, Way),
   save(canGotoExit, CanGotoExit),
   casesToDirection(PosMineur, ToGo, Mouvement),
   newPosFromMovment(PosMineur, Mouvement, NewPos),
   mapNavigateTo(NavMap, PosMineur, TempMap1),
   getCurrentCaseInNavMap(TempMap1, Case),
   changeCaseType(Case, 1, NewCase),
   setCurrentCaseInNavMap(TempMap1, NewCase, TempMap2),
   mapNavigateTo(TempMap2, NewPos, TempMap3),
   getCurrentCaseInNavMap(TempMap3, Case3),
   not(getCaseType(Case3, no_way)),
   not(notSafeCase(TempMap3)),
   saveMinorOldPos(PosMineur),
   debugN('saved way'), !.
   %goTo(NavMap, CloserTarget, true, Mouvement), !.   % on se dplace
   
   
   
% Ralise une action sur la carte (on n'a pas encore assez de diamants)
action(NavMap, PosMineur, 0, Mouvement)
:- getCloserTarget(NavMap, PosMineur, CloserTarget), % on rcupre la cible la plus proche

   debug('best target :'), debugN(CloserTarget),
   
   save(canGotoExit, 0),
   
   mapNavigateTo(NavMap, PosMineur, NewNavMap),
   pathFinding(NewNavMap, CloserTarget, [ _, ToGo| Way]),
   
   save(way, Way),
   
   %debugN(PosMineur),
   
   casesToDirection(PosMineur, ToGo, Mouvement),
   saveMinorOldPos(PosMineur), !.
   
   %debug(M), !.
   %goTo(NavMap, CloserTarget, true, Mouvement), !.   % on se dplace
   



   
% Ralise une action sur la carte (on trace vers la sortie)
action(NavMap, PosMineur, 1, Mouvement)
:- getExitPos(NavMap, Exit), % on rcupre la sortie

   save(canGotoExit, 1),

   mapNavigateTo(NavMap, PosMineur, NewNavMap),
   pathFinding(NewNavMap, Exit, [ _, ToGo| Way], false, false),
   
   save(way, Way),

   casesToDirection(PosMineur, ToGo, Mouvement),
   saveMinorOldPos(PosMineur), !.
   
   

/*% Ralise une action sur la carte
action(NavMap, PosMineur, CanGotoExit, Mouvement)
:- %preTraitementAdjacentMap(Map, PosMineur, NewMap),              % traitement des obstacles adjacents
   %getNavigateMap(Map, [1, 1], NavigationMap),                    % get navigation Map
   getCloserTarget(NavMap, PosMineur, CloserTarget),              % on rcupre la cible la plus proche
   goTo(NavMap, CloserTarget, CanGotoExit, Mouvement), !.         % on se dplace   */