/* ------------------------------------------------
   Les 2 positions sont adjacentes ou confondues */

   % isNear(Pos1, Pos2)

isNear([X,Y1],[X,Y2]):- voisin(Y1,Y2), !.
isNear([X1,Y],[X2,Y]):- voisin(X1,X2), !.

voisin(A,A):- !.
voisin(A,B):- A is B+1, !.
voisin(A,B):- A is B-1, !.


/* ------------------------------------------------
   Distance entre deux positions */

   % getDist(Pos1, Pos2, Dist)

getDist([X1, Y1], [X2, Y2], Dist) :- Dist is (abs(X1 - X2) + abs(Y1 - Y2)).


/* ------------------------------------------------
   Vrai si Pos est une position */

   % isPosition(Pos)
   
isPosition([_, _]).


/* ------------------------------------------------
   Ajoute un element dans une liste trie de manire croissante */

   % addInAscOrderedList(Element, CurrentList, NewList)


% Si le poid du nouvel element est superieur  celui de l'element courrant, l'insere plus loin
addInAscOrderedList([NewWeigth, NewElement], [[Weigth, Element] | List], [[Weigth, Element] | NewList])
:- NewWeigth > Weigth,
   addInAscOrderedList([NewWeigth, NewElement], List, NewList), !.

% Si le poid du nouvel element est infrieur ou gal  celui de l'element courrant, l'inserer devant
addInAscOrderedList([NewWeigth, NewElement], [[Weigth, Element] | List], [[NewWeigth, NewElement], [Weigth, Element] | List])
:- NewWeigth =< Weigth, !.

% Si la liste est vide, on y met juste l'element
addInAscOrderedList(Element, [], [Element]):- !.


/* ------------------------------------------------
   get list size */
   
   % getListSize(List, Size)

getListSize([], 0).
getListSize([_|R], NB) :- getListSize(R, RNB), NB is RNB + 1.


saveMinorOldPos(Pos)
:- save(oldMineurPosition, Pos), !.



save(Key, Value)
:- recorded(Key, _, Reference),
   erase(Reference),
   recorda(Key, Value), !.

save(Key, Value)
:- recorda(Key, Value), !.




/* ------------------------------------------------
   essais d'aller du point Start au point Go, en ligne droite */
   
   % casesToDirection(Start, Go, Move)

casesToDirection([X, _], [Xgo,  _ ], [ 1,  0]) :- X < Xgo, !.
casesToDirection([X, _], [Xgo,  _ ], [-1,  0]) :- X > Xgo, !.
casesToDirection([_, Y], [ _ , Ygo], [ 0,  1]) :- Y < Ygo, !.
casesToDirection([_, Y], [ _ , Ygo], [ 0, -1]) :- Y > Ygo, !.

casesToDirection(_, _, [ 0, 0]) :- !.



/* ------------------------------------------------
   Down est juste en dessous de Pos */

   % isJustUpper(Pos, Down)
   
   
isJustUpper([X, Y1], [X, Y2]) :- Y2 = Y1 + 1, !.


newPosFromMovment([X, Y], [DX, DY], [NX, NY])
:- NX is X + DX, NY is Y + DY, !.



/* ------------------------------------------------
   Prdiccats de dbug */

debugN( T ) :- open( 'trace.txt', append, L ), write( L, T ), nl( L ), close( L ).
debug( T )  :- open( 'trace.txt', append, L ), write( L, T ), write( L, ' '), close( L ).


debugN_fct(_)   :- !.
debug_fct(_)    :- !.

debugN_fct( T ) :- debugN(T).
debug_fct( T )  :- debug(T).

debugN_pf(_)   :- !.
debug_pf(_)    :- !.

debugN_pf( T ) :- debugN(T).
debug_pf( T )  :- debug(T).

debugN_mm(_)   :- !.
debug_mm(_)    :- !.

debugN_mm( T ) :- debugN(T).
debug_mm( T )  :- debug(T).

