/* ------------------------------------------------
   Traite une carte pour la mettre dans notre format */

   % dealList(List, Width, Map)
   % dealList(List, RestInCurrentWidth, RealWidth, Map, CurrentLineNumber)
   
   
   
% essai : dealList([2, 1, 1, 1, 1, 1, 1, 1, 1], 3, M).

% rappel de la fonction avec un parametre en plus
dealList(List, Width, NavigationMap)
:- dealList(List, Width, Width, SimpleMap, 1),
   getNavigateMap(SimpleMap, [0,0], TempNavMap),
   dealMap(TempNavMap, NavigationMap), !.

% on a fini la ligne
dealList([Type|List], 1, Width, [[[TypeCase, no_blocked, Type, false]]|Map], Height)
:- getCaseTypeFromInt(Type, TypeCase),
   NewHeight is Height + 1,
   dealList(List, Width, Width, Map, NewHeight), !.

% on traite une case quelconque
dealList([Type|List], Rest, Width, [[[TypeCase, no_blocked, Type, false]|Line]|Map], Height)
:- getCaseTypeFromInt(Type, TypeCase),
   NewRest is Rest - 1,
   dealList(List, NewRest, Width, [Line|Map], Height), !.

% On a rcupr
dealList([], _, Width, [], Height) :- NewHeight is Height - 1, recorda(mapSize, [Width, NewHeight]), !.

%dealList(L, _, _, _, _) :- debugN(L).


/* ------------------------------------------------
   Les diffrents types de cases */

   % getCaseType(Case, Type)

getCaseType([Type | _], Type).

getCaseRealType([_, _, CaseType | _], CaseType).


/* ------------------------------------------------
   Traite une carte ( cases interdites : monstres ... ) */

   %  dealMap(Map, NewMap)

% Prdicat pas encore fait ...
dealMap(Map, Map).


/* ------------------------------------------------
   vrai si la case est une cible */

   % caseIsTarget(Case)

caseIsTarget(Case) :- getCaseType(Case, diam), !.
%.............. TODO ................
% add other target kind


/* ------------------------------------------------
   Les diffrents types de cases */

   % getCaseTypeFromInt(Type, TypeCase)

getCaseTypeFromInt(0, vide).
getCaseTypeFromInt(1, terre).
getCaseTypeFromInt(2, diam).
getCaseTypeFromInt(3, pierre).
getCaseTypeFromInt(4, no_way).
getCaseTypeFromInt(5, vide).
getCaseTypeFromInt(6, no_way).
getCaseTypeFromInt(7, no_way).
getCaseTypeFromInt(8, no_way).
getCaseTypeFromInt(9, no_way).
getCaseTypeFromInt(16, monstre).
getCaseTypeFromInt(17, monstre).
getCaseTypeFromInt(20, no_way).
getCaseTypeFromInt(21, no_way).
getCaseTypeFromInt(22, exit).


/* ------------------------------------------------
   Ce type de terrain glisse */

isCaseTypeSlide(2). % diam
isCaseTypeSlide(3). % pierre

isCaseTypeSlide(6). % mur
isCaseTypeSlide(7). % mur
isCaseTypeSlide(8). % mur
isCaseTypeSlide(9). % mur

isCaseTypeSlide(20). % mur
isCaseTypeSlide(21). % mur


/* ------------------------------------------------
   Le mineur ne peut pas aller sur cette case */

   % notWalkableType(Type)

notWalkableType(no_way).
notWalkableType(monstre).
notWalkableType(exit) :- not(recorded(canGotoExit, 1)).



/* ------------------------------------------------
   tager la case comme non traite */
   
setCaseUnDealed([TypeCase, Blocked, Type, _ | R], [TypeCase, Blocked, Type, false | R]).

setCaseDealed([TypeCase, Blocked, Type, _ | R], [TypeCase, Blocked, Type, true | R]).

isCaseDealed([_, _, _, true | _]).

changeCaseType([_, Blocked, _ | R], Type, [TypeCase, Blocked, Type | R])
:- getCaseTypeFromInt(Type, TypeCase), !.


/* ------------------------------------------------
   On enregistre la carte */

   % saveMap(NavMap)

/*saveMap(_)
:- recorded(map, _, Reference),
   erase(Reference), !. */

saveMap(NavMap)
:- mapNavigateTo(NavMap, [0,0], OriginNavMap),
   save(map, OriginNavMap), !.
   
   
/* ------------------------------------------------
   On charge la carte */

   % loadMap(NavMap)

loadMap(NavMap)
:- recorded(map, NavMap), !.


/* ------------------------------------------------
   On rcupre la taille de la carte */

   % getMapSize([Width, Height])

getMapSize([Width, Height])
:- recorded(mapSize, [Width, Height]), !.


/* ------------------------------------------------
   On rcupre le monstre de la case */

   % getMonsterFromCase(Case, Monster)
   
getMonsterFromCase(Case, Monster).
%.............. TODO ................
% creer le prdicat


/* ------------------------------------------------
   On trouve la sortie de la carte */

   % getExitPos(Map, Pos)

getExitPos(Map, Pos)
:- mapNavigateTo(Map, [0,0], NewMap),
   getExitPos_(NewMap, Pos), !.
   
   
getExitPos_(Map, Pos)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, exit),
   getCurrentCasePosInNavMap(Map, Pos), !.
   
getExitPos_(Map, Pos)
:- getNextListCaseInNavMap(Map, NewMap),
   getExitPos_(NewMap, Pos), !.