
/* ------------------------------------------------
   Calcul l'tat de la map apres mouvement */

   % pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap)


%pathFinding_computeMap(Map, Direction, Map, false).

pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap)
:- pathFinding_preCompute(Map, TempMap),
   getCurrentCasePosInNavMap(Map, Pos),
   pathFinding_computeMinerMod(TempMap, Pos, Direction, TempMap2, TempHasMovedMap),
   mapNavigateTo(TempMap2, [0,0], TempMap3),
   mapNavigateTo(Map,      [0,0], OMap),
   pathFinding_getParentFromDirection(Pos, Direction, OldPos),
   pathFinding_dealCase(OMap, TempMap3, Pos, OldPos, TempHasMovedMap, TempMap4, HasMovedMap),
   mapNavigateTo(TempMap4, Pos, NewMap), !.


/* ------------------------------------------------
   Fait bouger toute la carte */

   % pathFinding_dealCase(OriginMap, Map, MinerPos, HasMovedMapYet, NewMap, HasMovedMap)


% la case est dja traite
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   isCaseDealed(Case),
   getNextListCaseInNavMap(Map, TempMap),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   
% la case est un boulet ou diamant avec du vide en dessous
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   ( getCaseType(Case, diam); getCaseType(Case, pierre) ),
   
   % si en dessous ce n'est pas le mineur ou l'ancien mineur
   getCurrentCasePosInNavMap(Map, Pos),
   not(isJustUpper(Pos, MinerPos)),
   not(isJustUpper(Pos, OldMinerPos)),
   
   % il y a du vide en dessous
   getNextLineSameXInNavMap(OriginMap, TempOriginMap),
   getCurrentCaseInNavMap(TempOriginMap, BottomCase),
   getCaseType(BottomCase, vide),
   
   % on rcupre ce qu'il y a reellement sur la case
   getCaseRealType(Case, RealType),
   
   % on met du vide sur cette case et on dit qu'elle est traite
   changeCaseType(Case, 0, NewCase),
   setCaseDealed(NewCase, NewCase2),
   setCurrentCaseInNavMap(Map, NewCase2, TempMap),
   
   % on deplace l'objet case du dessous et on dit que la case est dj modifie
   getNextLineSameXInNavMap(TempMap, TempMap2),
   getCurrentCaseInNavMap(TempMap2, TempBottomCase),
   setCaseDealed(TempBottomCase, TempBottomCase2),
   changeCaseType(TempBottomCase2, RealType, TempBottomCase3),
   setCurrentCaseInNavMap(TempMap2, TempBottomCase3, TempMap3),
   
   % on repasse case du dessus
   getPreviousLineSameXInNavMap(TempMap3, TempMap4),
   
   
   getNextListCaseInNavMap(TempMap4, TempMap5),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap5, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.
   

   
% la case est un boulet ou diamant avec terrain glissant en dessous en dessous
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   ( getCaseType(Case, diam); getCaseType(Case, pierre) ),

   % si en dessous ce n'est pas le mineur ou l'ancien mineur
   getCurrentCasePosInNavMap(Map, Pos),
   not(isJustUpper(Pos, MinerPos)),
   not(isJustUpper(Pos, OldMinerPos)),

   % il y a du glissant en dessous
   getNextLineSameXInNavMap(OriginMap, TempOriginMap),
   getCurrentCaseInNavMap(TempOriginMap, BottomCase),
   getCaseRealType(BottomCase, RealType),
   isCaseTypeSlide(RealType),

   % on rcupre ce qu'il y a reellement sur la case
   %getCaseRealType(Case, RealType),
   
   pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   
% on passe simplement  la case suivante
pathFinding_dealCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getNextListCaseInNavMap(Map, TempMap),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   
% il n'y a plus de cases
pathFinding_dealCase(_, Map, _, _, HasMovedMap, Map, HasMovedMap) :- !.



/* ------------------------------------------------
   On est sur un terrain glissant */

   % pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)

% la pierre / diamant peut glisser des deux cots
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos),
   pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos),

   % on rcupre le contenu reel de la case
   getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, RealType),

   % on met du vide
   setCaseDealed(Case, TempCase),
   changeCaseType(TempCase, 0, TempCase2),
   setCurrentCaseInNavMap(Map, TempCase2, TempMap),

   % on va a gauche
   getPreviousCaseInNavMap(TempMap, LeftMap),
   getCurrentCaseInNavMap(LeftMap, LeftCase),

   % on met l'objet
   setCaseDealed(LeftCase, TempLeftCase),
   changeCaseType(TempLeftCase, RealType, TempLeftCase2),
   setCurrentCaseInNavMap(LeftMap, TempLeftCase2, NewLeftMap),

   % on va 2 x  droite
   getNextCaseInNavMap(NewLeftMap, TempMiddle),
   getNextCaseInNavMap(TempMiddle, RightMap),
   getCurrentCaseInNavMap(RightMap, RightCase),

   % on met l'objet
   setCaseDealed(RightCase, TempRightCase),
   changeCaseType(TempRightCase, RealType, TempRightCase2),
   setCurrentCaseInNavMap(RightMap, TempRightCase2, NewRightMap),

   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, NewRightMap, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.



% la pierre / diamant peut glisser seulement  gauche
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos),

   % on rcupre le contenu reel de la case
   getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, RealType),

   % on met du vide
   setCaseDealed(Case, TempCase),
   changeCaseType(TempCase, 0, TempCase2),
   setCurrentCaseInNavMap(Map, TempCase2, TempMap),

   % on va a gauche
   getPreviousCaseInNavMap(TempMap, LeftMap),
   getCurrentCaseInNavMap(LeftMap, LeftCase),

   % on met l'objet
   setCaseDealed(LeftCase, TempLeftCase),
   changeCaseType(TempLeftCase, RealType, TempLeftCase2),
   setCurrentCaseInNavMap(LeftMap, TempLeftCase2, NewLeftMap),

   % on va 2 x  droite
   getNextCaseInNavMap(NewLeftMap, TempMiddle),
   getNextCaseInNavMap(TempMiddle, RightMap),

   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, RightMap, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.



% la pierre / diamant peut glisser seulement  droite
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, _, NewMap, HasMovedMap)
:- pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos),

   % on rcupre le contenu reel de la case
   getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, RealType),

   % on met du vide
   setCaseDealed(Case, TempCase),
   changeCaseType(TempCase, 0, TempCase2),
   setCurrentCaseInNavMap(Map, TempCase2, TempMap),

   % on va  droite
   getNextCaseInNavMap(TempMap, RightMap),
   getCurrentCaseInNavMap(RightMap, RightCase),

   % on met l'objet
   setCaseDealed(RightCase, TempRightCase),
   changeCaseType(TempRightCase, RealType, TempRightCase2),
   setCurrentCaseInNavMap(RightMap, TempRightCase2, NewRightMap),

   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, NewRightMap, MinerPos, OldMinerPos, true, NewMap, HasMovedMap), !.



% la pierre / diamant ne peut pas glisser
pathFinding_slideCase(OriginMap, Map, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap)
:- getNextListCaseInNavMap(Map, TempMap),
   getNextListCaseInNavMap(OriginMap, NewOriginMap),
   pathFinding_dealCase(NewOriginMap, TempMap, MinerPos, OldMinerPos, HasMovedMapYet, NewMap, HasMovedMap), !.
   
   



/* ------------------------------------------------
   On peut glisser a droite ou a gauche */

   % pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos)
   % pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos)


pathFinding_canSlideLeft(OriginMap, MinerPos, OldMinerPos)
:- % on va a gauche
   getPreviousCaseInNavMap(OriginMap, LeftOriginMap),

   % le mineur n'est pas a gauche
   getCurrentCasePosInNavMap(LeftOriginMap, Pos),
   Pos \= MinerPos,
   Pos \= OldMinerPos,

   % il y a du vide a gauche
   getCurrentCaseInNavMap(LeftOriginMap, LeftCase),
   getCaseType(LeftCase, vide),

   % on va en bas a gauche
   getNextLineSameXInNavMap(LeftOriginMap, LeftBottomOriginMap),

   % le mineur n'est pas en bas a gauche
   getCurrentCasePosInNavMap(LeftBottomOriginMap, Pos2),
   Pos2 \= MinerPos,
   Pos2 \= OldMinerPos,

   % il y a du vide en bas  droite
   getCurrentCaseInNavMap(LeftBottomOriginMap, LeftBottomCase),
   getCaseType(LeftBottomCase, vide), !.



pathFinding_canSlideRight(OriginMap, MinerPos, OldMinerPos)
:- % on va a droite
   getNextCaseInNavMap(OriginMap, RightOriginMap),

   % le mineur n'est pas a droite
   getCurrentCasePosInNavMap(RightOriginMap, Pos),
   Pos \= MinerPos,
   Pos \= OldMinerPos,

   % il y a du vide a droite
   getCurrentCaseInNavMap(RightOriginMap, RightCase),
   getCaseType(RightCase, vide),

   % on va en bas a droite
   getNextLineSameXInNavMap(RightOriginMap, RightBottomOriginMap),

   % le mineur n'est pas en bas a droite
   getCurrentCasePosInNavMap(RightBottomOriginMap, Pos2),
   Pos2 \= MinerPos,
   Pos2 \= OldMinerPos,

   % il y a du vide en bas  droite
   getCurrentCaseInNavMap(RightBottomOriginMap, RightBottomCase),
   getCaseType(RightBottomCase, vide), !.
   




/* ------------------------------------------------
   Fait bouger le mineur et modifie l'environement directement modifi ( pousser les blocs ) */
   
   % pathFinding_computeMinerMod(Map, Pos, Direction, NewMap, HasMovedMap)

   
% on dplace une pierre
pathFinding_computeMinerMod(Map, Pos, Direction, NewMap, true)
:- mapNavigateTo(Map, Pos, TempMap),
   getCurrentCaseInNavMap(TempMap, Case),
   getCaseType(Case, pierre),
   getCaseRealType(Case, CaseType),
   changeCaseType(Case, 0, NewCase),      % on met du vide
   setCurrentCaseInNavMap(TempMap, NewCase, TempMap2),
   mapNavigatePushTo(TempMap2, Direction, TempMap3),
   pathFinding_computeMinerMod_push(TempMap3, Direction, CaseType, NewMap), !.
   
   
% si on ne pouse rien, le mineur ne dplace pas l'environement
pathFinding_computeMinerMod(Map, _, _, Map, false) :- !.



/* ------------------------------------------------
   Dplace un bloc de pierres */

   % pathFinding_computeMinerMod_push(Map, Direction, CaseType, NewMap)

% il y a du vide, on a fini de dplacer
pathFinding_computeMinerMod_push(Map, _, CaseType, NewMap)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   changeCaseType(Case, CaseType, NewCase),
   setCaseDealed(NewCase, NewCase2),
   setCurrentCaseInNavMap(Map, NewCase2, NewMap), !.
   
   
% ce n'est pas du vide on le dplace
pathFinding_computeMinerMod_push(Map, Direction, CaseType, NewMap)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseRealType(Case, HereType),
   changeCaseType(Case, CaseType, NewCase),
   setCaseDealed(NewCase, NewCase2),
   setCurrentCaseInNavMap(Map, NewCase2, TempMap),
   mapNavigatePushTo(TempMap, Direction, TempMap2),
   pathFinding_computeMinerMod_push(TempMap2, Direction, HereType, NewMap), !.
   


/* ------------------------------------------------
   Tager chaque case de la carte comme non traite */

   % pathFinding_preCompute(Map, NewMap)

pathFinding_preCompute(Map, NewMap)
:- getCurrentCasePosInNavMap(Map, Pos),
   mapNavigateTo(Map, [0, 0], TempMap),
   pathFinding_preCompute_(TempMap, TempMap2),
   mapNavigateTo(TempMap2, Pos, NewMap), !.
   
   
   % pathFinding_preCompute_(Map, NewMap)
   
% On traite la case
pathFinding_preCompute_(Map, NewMap)
:- getCurrentCaseInNavMap(Map, Case),
   setCaseUnDealed(Case, NewCase),
   setCurrentCaseInNavMap(Map, NewCase, TempMap),
   pathFinding_preComputeNextCase(TempMap, NewMap), !.
   

% Il y a une case suivante, on y va
pathFinding_preComputeNextCase(Map, NewMap)
:- getNextListCaseInNavMap(Map, TempMap),
   pathFinding_preCompute_(TempMap, NewMap), !.
   
% Il n'y a pas de case suivante, on termine
pathFinding_preComputeNextCase(Map, Map).
   