/* ------------------------------------------------
   Ajoute les cases adjacentes  la derniere case ajoute a la Close List  la Open List */

   % pathFinding_addAdjacentCasesToOpenList(Info, NewInfo)

pathFinding_addAdjacentCasesToOpenList(Info, NewInfo)
:- pathFinding_getCloseList(Info, CloseList),
   pathFinding_getLastAddedMap(CloseList, Map),
   pathFinding_getLastAddedId(CloseList, ParentId),

   pathFinding_changeBreakPoint(Info, [], Info1),
   
   %mapNavigateTo(Map, PosMineur, TempMap1),
   getCurrentCaseInNavMap(Map, Case),
   changeCaseType(Case, 1, NewCase),
   setCurrentCaseInNavMap(Map, NewCase, TempMap),

   pathFinding_addTopCase(TempMap, ParentId, Info1, Info2),
   pathFinding_addLeftCase(TempMap, ParentId, Info2, Info3),
   pathFinding_addRightCase(TempMap, ParentId, Info3, Info4),
   pathFinding_addBottomCase(TempMap, ParentId, Info4, Info5),
   
   pathFinding_addCurrentCase(TempMap, ParentId, Info5, Info6),
   

   pathFinding_getBreakPoint(Info2, BreakPoint_1),
   pathFinding_getBreakPoint(Info3, BreakPoint_2),
   pathFinding_getBreakPoint(Info4, BreakPoint_3),
   pathFinding_getBreakPoint(Info5, BreakPoint_4),
   pathFinding_getBreakPoint(Info6, BreakPoint_5),

   pathFinding_dealBreakPoint(BreakPoint_1, BreakPoint_2, BreakPoint_3, BreakPoint_4, BreakPoint_5, BreakPoint),

   pathFinding_changeBreakPoint(Info6, BreakPoint, NewInfo), !.



/* ------------------------------------------------
   Essai d'ajouter la case  la liste ouverte */

   % pathFinding_tryAddCase(Map, ParentId, Destination, OpenList , CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)

% on ne peut pas marcher sur ce type de terrain
pathFinding_tryAddCase(Map, _, _, Info, Info)
:- getCurrentCaseInNavMap(Map, Case),
   debug_pf('try to add :'),
   getCurrentCasePosInNavMap(Map, Pos),
   debug_pf(Pos),
   getCaseType(Case, Type),
   debug_pf(Type),
   notWalkableType(Type),
   debugN_pf('impossible to go here'), !.    % C'est un no_way ou un monstre


% cette case n'est pas scurise (monstre a proximite, boulet au dessus)
%pathFinding_tryAddCase(Map, _, _, OpenList , _, LastId, OpenList, LastId, _, _, [], _)
pathFinding_tryAddCase(Map, _, _, Info, Info)
:- notSafeCase(Map),
   debugN_pf('not safe'), !.


% grer si la case est un boulet ( pousser )
%pathFinding_tryAddCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
pathFinding_tryAddCase(Map, ParentId, Direction, Info, NewInfo)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, pierre),
   debugN_pf('yes pierre'),
   pathFinding_tryAddCaseRock(Map, ParentId, Direction, Info, NewInfo),
   debugN_pf('can go on this rock'), !.


% rien n'empeche l'ajout de la case
%pathFinding_tryAddCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
pathFinding_tryAddCase(Map, ParentId, Direction, Info, NewInfo)
:- getCurrentCaseInNavMap(Map, Case),
   not(getCaseType(Case, pierre)),
   debugN_pf('YES ADDED'),
   pathFinding_addCase(Map, ParentId, Direction, Info, NewInfo), !.

% dernier cas : on n'ajoute pas la case
pathFinding_tryAddCase(_, _, _, Info, Info)
:- debugN_pf('can''t move rock'), !.


/* ------------------------------------------------
   Ajoute la case  la Open List */

   % pathFinding_addCase(Map, ParentId, Destination, OpenList , CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, Majoration)


pathFinding_addCase(Map, ParentId, Direction, Info, NewInfo)
:- pathFinding_addCase(Map, ParentId, Direction, 0, Info, NewInfo), !.


%pathFinding_addCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, Maj)
pathFinding_addCase(Map, ParentId, Direction, Maj, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, Pos),                                           % rcupre la position
   pathFinding_getDestination(Info, Destination),
   getDist(Pos, Destination, FlyDist),                                            % rcupre la distance entre la destination et la nouvelle position ( vol d'oiseau )
   pathFinding_getCloseList(Info, CloseList),
   pathFinding_getOpenList(Info, OpenList),
   pathFinding_getDistLastAddedMap(CloseList, Dist),                              % rcupre la distance au dpart de la case prcdente
   NewDist is (Dist + 1 + Maj),
   Weight is (NewDist + FlyDist * 2),                                             % calcul le poid ( somme des distances + majoration )

   not(pathFinding_existInCloseList(Pos, Weight, CloseList)),                     % la case n'est pas prsente dans les 2 listes avec des coefficients trop bas
   not(pathFinding_existInOpenList(Pos, Weight, OpenList)),
   
   %pathFinding_addInChosenList(Map, ParentId, Direction, Weight, NewDist, FlyDist, Info, NewInfo),

   %pathFinding_deleteInOpenList(Pos, Weight, OpenList, TempOpenList),

   pathFinding_getMustBeAbleToLeave(Info, MustBeAbleToLeave),
   
   
   getCurrentCasePosInNavMap(Map, Pos),
   pathFinding_getParentFromDirection(Pos, Direction, ParentPos),
   mapNavigateTo(Map, ParentPos, TempMap),
   getCurrentCaseInNavMap(TempMap, Case),
   changeCaseType(Case, 0, NewCase),
   setCurrentCaseInNavMap(TempMap, NewCase, TempMap2),
   mapNavigateTo(TempMap2, Pos, TempMap3),
   
   

   pathFinding_doWeComputeMap(TempMap3, Direction, CloseList, NewMap, HasMovedMap),
   
   /*(
     (
       not(pathFinding_existInCloseList(Pos, Weight, CloseList)),
       not(pathFinding_existInOpenList(Pos, Weight, OpenList)),
       NewDist2 is NewDist
     )
     ;
     (
       HasMovedMap = true,
       NewDist2 is NewDist + 10
     )
   ),      */

   %pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap),                   % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement
   %pathFinding_isAbleToLeave(NewMap, HasMovedMap, MustBeAbleToLeave),             % on teste si le nouveau mouvement nous permet toujours de sortir

   pathFinding_getLastCaseId(Info, LastId),
   pathFinding_getLasMapId(Info, LastMapId),

   NewLastId is LastId + 1,                                                       % gnration de l'id
   debug_pf('on ajoute la case'), debug_pf('id :'), debug_pf(NewLastId),
   debug_pf('parent :'), debugN_pf(ParentId),

   % format : [ StartDist, FlyDist, ParentId, CaseId, MapId, MapFrame, Map, HasMovedMap ]

   addInAscOrderedList([ Weight , [ NewDist, FlyDist, ParentId, NewLastId, LastMapId, 0, NewMap, HasMovedMap ] ], OpenList, NewOpenList),  % ajoute la case  la liste ouverte

   pathFinding_getCanGoToNearTarget(Info, CanGoToNearTarget),

   pathFinding_isBreakPoint(Map, CanGoToNearTarget, BreakPoint),                  % test si la case ajoute doit retourner un breakpoint

   pathFinding_changeBreakPoint(Info, BreakPoint, Info2),
   pathFinding_changeOpenList(Info2, NewOpenList, Info3),
   pathFinding_changeLastCaseId(Info3, NewLastId, NewInfo), !.
   
   
   
      /*

% Ajoute la case  la wait list
pathFinding_addCase(Map, ParentId, Direction, Maj, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, Pos),                                           % rcupre la position
   pathFinding_getDestination(Info, Destination),
   getDist(Pos, Destination, FlyDist),                                            % rcupre la distance entre la destination et la nouvelle position ( vol d'oiseau )
   pathFinding_getWaitList(Info, WaitList),
   %pathFinding_getOpenList(Info, OpenList),
   pathFinding_getCloseList(Info, CloseList),
   pathFinding_getDistLastAddedMap(CloseList, Dist),                              % rcupre la distance au dpart de la case prcdente
   majorForAlreadyExisting(Maj2),
   NewDist is (Dist + 1 + Maj + Maj2),
   Weight is (NewDist + FlyDist * 2),                                             % calcul le poid ( somme des distances + majoration )

   %pathFinding_getMustBeAbleToLeave(Info, MustBeAbleToLeave),

   %pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap),                   % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement
   %pathFinding_isAbleToLeave(NewMap, HasMovedMap, MustBeAbleToLeave),             % on teste si le nouveau mouvement nous permet toujours de sortir
   
   pathFinding_getMustBeAbleToLeave(Info, MustBeAbleToLeave),
   pathFinding_doWeComputeMap(Map, Direction, CloseList, NewMap, HasMovedMap),

   pathFinding_getLastCaseId(Info, LastId),
   pathFinding_getLasMapId(Info, LastMapId),

   NewLastId is LastId + 1,                                                       % gnration de l'id
   debug_pf('on ajoute la case dans waiting list'), debug_pf('id :'), debug_pf(NewLastId),
   debug_pf('parent :'), debugN_pf(ParentId),

   % format : [ StartDist, FlyDist, ParentId, CaseId, MapId, MapFrame, Map ]
   
      % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % ||||||||||||||||||||||||||||||||||||||||||||||||||||||
   % TODO MapIsMoving true or false

   addInAscOrderedList([ Weight , [ NewDist, FlyDist, ParentId, NewLastId, LastMapId, 0, NewMap, HasMovedMap ] ], WaitList, NewWaitList),  % ajoute la case  la liste ouverte

   %pathFinding_getCanGoToNearTarget(Info, CanGoToNearTarget),

   %pathFinding_isBreakPoint(Map, CanGoToNearTarget, BreakPoint),                  % test si la case ajoute doit retourner un breakpoint

   %pathFinding_changeBreakPoint(Info, BreakPoint, Info2),
   pathFinding_changeWaitList(Info, NewWaitList, Info2),
   pathFinding_changeLastCaseId(Info2, NewLastId, NewInfo), !.
                                                         */

% on ne peut pas ajouter la case  la liste ouverte
%pathFinding_addCase(_, _, _, OpenList, _, LastId, OpenList, LastId, _, _, [], _, _) :- !.
pathFinding_addCase(_, _, _, _, Info, Info) :- !.




/* ------------------------------------------------
   Recalcule la map ou pas celon s'il y a des changements a effectuer ou pas */

   % pathFinding_doWeComputeMap(Map, Direction, CloseList, NewMap, HasMovedMap)

% Si on vient d'une case qui bouge
pathFinding_doWeComputeMap(Map, Direction, CloseList, NewMap, HasMovedMap)
:- pathFinding_getLastAddedHasMoved(CloseList, true),           % la derniere case bougait
   debugN_mm('recompute 1 !'),
   pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap),
   debug_mm('HasMovedMap : '),
   debugN_mm(HasMovedMap), !.  % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement

% Si atteri sur un diamant ou pierre
pathFinding_doWeComputeMap(Map, Direction, _, NewMap, HasMovedMap)
:- getCurrentCaseInNavMap(Map, Case),
   (getCaseType(Case, diam) ; getCaseType(Case, pierre)),
   debugN_mm('recompute 2 !'),
   pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap), !.  % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement

% Si on libre du vide et que ce vide permet un dplacement
pathFinding_doWeComputeMap(Map, Direction, _, NewMap, HasMovedMap)
:- getCurrentCasePosInNavMap(Map, Pos),
   pathFinding_getParentFromDirection(Pos, Direction, OldPos),
   mapNavigateTo(Map, OldPos, OldPosMap),
   doesCaseCanMakeMoves(OldPosMap, Pos),
   debugN_mm('recompute 3 !'),
   pathFinding_computeMap(Map, Direction, NewMap, HasMovedMap), !.  % on calcule la nouvelle carte gnre par le dplacement, HasMovedMap true si la carte est en mouvement

% Si la carte ne bouge pas
pathFinding_doWeComputeMap(Map, _, _, Map, false) :- debugN_mm('no compute ...'), !.




/* ------------------------------------------------
   La libration de la case Map permet t'elle de mettre en mouvement la carte ?
   Pos est la nouvelle position du mineur */

   % doesCaseCanMakeMoves(Map, Pos)


% il y a une pierre ou un diamant au dessus
doesCaseCanMakeMoves(Map, _)
:- getPreviousLineSameXInNavMap(Map, NewMap),
   getCurrentCaseInNavMap(NewMap, Case),
   (getCaseType(Case, diam) ; getCaseType(Case, pierre)), !.


% il y a du vide au dessus avec un objet glissant  gauche ou a droite
doesCaseCanMakeMoves(Map, Pos)
:- getPreviousLineSameXInNavMap(Map, NewMap),
   getCurrentCasePosInNavMap(NewMap, UpPos),

   UpPos \= Pos,                                % il n'y a pas le mineur

   ((
      getPreviousCaseInNavMap(NewMap, TempMap1),
      getCurrentCaseInNavMap(TempMap1, Case1),
      (getCaseType(Case1, diam) ; getCaseType(Case1, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap1, TempMap1_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap1_2, Case1_2),             % on rcupre la case
      getCaseRealType(Case1_2, Case1_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case1_2_Type)                            % ca glisse
   );(
      getNextCaseInNavMap(NewMap, TempMap2),
      getCurrentCaseInNavMap(TempMap2, Case2),
      (getCaseType(Case2, diam) ; getCaseType(Case2, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap2, TempMap2_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap2_2, Case2_2),             % on rcupre la case
      getCaseRealType(Case2_2, Case2_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case2_2_Type)                            % ca glisse
   )), !.


% il y a un objet glissant  gauche ou a droite
doesCaseCanMakeMoves(Map, _)
:- ((
      getPreviousCaseInNavMap(Map, TempMap1),
      getCurrentCaseInNavMap(TempMap1, Case1),
      (getCaseType(Case1, diam) ; getCaseType(Case1, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap1, TempMap1_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap1_2, Case1_2),             % on rcupre la case
      getCaseRealType(Case1_2, Case1_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case1_2_Type)                            % ca glisse
   );(
      getNextCaseInNavMap(Map, TempMap2),
      getCurrentCaseInNavMap(TempMap2, Case2),
      (getCaseType(Case2, diam) ; getCaseType(Case2, pierre)), % la case  est pierre ou diamant
      getNextLineSameXInNavMap(TempMap2, TempMap2_2),          % on va en dessous
      getCurrentCaseInNavMap(TempMap2_2, Case2_2),             % on rcupre la case
      getCaseRealType(Case2_2, Case2_2_Type),                  % on rcupre le type de la case
      isCaseTypeSlide(Case2_2_Type)                            % ca glisse
   )), !.
   
   
   

/* ------------------------------------------------
   Ajoute la case pierre  la Open List */

   % pathFinding_tryAddCaseRock(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
   % pathFinding_tryAddCaseRock(Map, ParentId, Direction, Info, NewInfo)

%pathFinding_tryAddCaseRock(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction)
pathFinding_tryAddCaseRock(Map, ParentId, Direction, Info, NewInfo)
:- maximumRockPushable(NB),
   debug_pf('NB geted'),
   pathFinding_canWalkInThisRockDirection(Map, Map, ParentId, Direction, NB, Info, NewInfo), !.
   
   
% On ne peut pas pousser vers le bas
pathFinding_canWalkInThisRockDirection(_, _, down, _, _, Info, Info) :- !.


% C'est le vide, on peut pousser par la
%pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, NB)
pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Direction, NB, Info, NewInfo)
:- NB > 0,
   mapNavigatePushTo(MovingMap, Direction, NewMap),
   getCurrentCaseInNavMap(NewMap, Case),
   getCaseType(Case, vide),
   majorForRockClimbing(Major),
   pathFinding_addCase(Map, ParentId, Direction, Major, Info, NewInfo), !.


% la case est un boulet ou un diamant, on continue de voir si on peut pousser
%pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint, Direction, NB)
pathFinding_canWalkInThisRockDirection(Map, MovingMap, ParentId, Direction, NB, Info, NewInfo)
:- NB > 0,
   mapNavigatePushTo(MovingMap, Direction, NewMap),
   getCurrentCaseInNavMap(NewMap, Case),
   ( getCaseType(Case, pierre) ; getCaseType(Case, diam) ),
   
   % il ne doit pas y avoir de vide en dessous
   mapNavigatePushTo(NewMap, down, TempMap),
   getCurrentCaseInNavMap(TempMap, TempCase),
   %not(getCaseType(TempCase, vide)),
   
   NewNB is NB - 1,
   pathFinding_canWalkInThisRockDirection(Map, NewMap, ParentId, Direction, NewNB, Info, NewInfo), !.


% Ce n'est pas le vide, on ne peut pas marcher ici
%pathFinding_canWalkInThisRockDirection(_, _, _, OpenList , _, LastId, OpenList, LastId, _, _, _, _, _) :- !.
pathFinding_canWalkInThisRockDirection(_, _, _, _, _, Info, Info) :- !.



/* ------------------------------------------------
   Ajoute la case du haut  la Open List */

   % pathFinding_addTopCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


%pathFinding_addTopCase(Map, ParentId, Destination, OpenList , CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)
pathFinding_addTopCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewY is Y - 1,                              % on dcrmente Y (vers le haut)
   mapNavigateTo(Map, [X, NewY], NewMap),      % on se dplace vers le haut
   pathFinding_tryAddCase(NewMap, ParentId, up, Info, NewInfo), !.


/* ------------------------------------------------
   Ajoute la case de gauche  la Open List */

   % pathFinding_addLeftCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


%pathFinding_addLeftCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)
pathFinding_addLeftCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewX is X - 1,                              % on dcrmente X (vers la gauche)
   mapNavigateTo(Map, [NewX, Y], NewMap),      % on se dplace vers la gauche
   pathFinding_tryAddCase(NewMap, ParentId, left, Info, NewInfo), !.


/* ------------------------------------------------
   Ajoute la case de droite  la Open List */

   % pathFinding_addRightCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


pathFinding_addRightCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewX is X + 1,                              % on incrmente X (vers la droite)
   mapNavigateTo(Map, [NewX, Y], NewMap),      % on se dplace vers la droite
   pathFinding_tryAddCase(NewMap, ParentId, right, Info, NewInfo), !.


/* ------------------------------------------------
   Ajoute la case du bas  la Open List */

   % pathFinding_addBottomCase(Map, ParentId, Destination, OpenList, CloseList, LastId, NewOpenList, NewLastId, CanGoToNearTarget, MustBeAbleToLeave, BreakPoint)


pathFinding_addBottomCase(Map, ParentId, Info, NewInfo)
:- getCurrentCasePosInNavMap(Map, [X, Y]),     % on rcup la position
   NewY is Y + 1,                              % on incrmente Y (vers le bas)
   mapNavigateTo(Map, [X, NewY], NewMap),      % on se dplace vers le bas
   pathFinding_tryAddCase(NewMap, ParentId, down, Info, NewInfo), !.
   

/* ------------------------------------------------
   Ajoute la case courante (pas de mouvement)  la Open List */

   % pathFinding_addCurrentCase(Map, ParentId, Info, NewInfo)
   
   
pathFinding_addCurrentCase(Map, ParentId, Info, NewInfo)
:- pathFinding_tryAddCase(Map, ParentId, here, Info, NewInfo), !.