



/* ------------------------------------------------
   Create close list  */

   % pathfinding_createCloseList(StartMap, Destination, CloseList)

   % Close list element format : [ StartDist, FlyDist, ParentId, CaseId, MapId, MapFrame, Map, MapIsMoving ]

pathfinding_createCloseList(StartMap, MapIsMoving, Destination, [ [ 0, Dist, 0, 1, 1, 0, StartMap, MapIsMoving ] ])
:- getCurrentCasePosInNavMap(StartMap, Pos),
   getDist(Pos, Destination, DistFly),
   Dist is DistFly * 2, !.


/* ------------------------------------------------
   ajouter une case  une close list  */

   % pathFinding_addCaseInCloseList(CloseList, ParentId, CaseId, Map, NewCloseList)

% simple version /!\ use carefully
pathFinding_addCaseInCloseList(CloseList, ParentId, CaseId, Map, MapIsMoving, [ [ 0, 0, ParentId, CaseId, -1, -1, Map, MapIsMoving ] | CloseList ]).



/* ------------------------------------------------
   Rcuprer la derniere carte ajoute dans la Close List  */

   % pathFinding_getLastAddedMap(CloseList, Map)

pathFinding_getLastAddedMap([ [_ , _, _, _, _, _, Map | _ ] | _ ], Map).


/* ------------------------------------------------
   Rcuprer le dernier Id ajoute dans la Close List  */

   % pathFinding_getLastAddedId(CloseList, Id)


pathFinding_getLastAddedId([ [_ , _, _, Id | _ ] | _ ], Id).


/* ------------------------------------------------
   Rcuprer si le dernier element ajout tait une carte en mouvement  */

   % pathFinding_getLastAddedHasMoved(CloseList, HasMoved)


pathFinding_getLastAddedHasMoved([ [_ , _, _, _, _, _, _, HasMoved | _ ] | _ ], HasMoved).



/* ------------------------------------------------
   Rcuprer la distance au dpart de la derniere carte ajoute dans la Close List  */

   % pathFinding_getDistLastAddedMap(CloseList, Map)

pathFinding_getDistLastAddedMap([ [Dist | _ ] | _ ], Dist).


/* ------------------------------------------------
   la case est dj prsente dans les 2 listes avec des coefficients trop bas */

   % pathFinding_existInCloseList(Pos, Weight, CloseList)


% on trouve la case
pathFinding_existInCloseList(Pos, Weight, [ [Dist, DistFly, _, _, _, _, Map | _ ] | _ ])
:- getCurrentCasePosInNavMap(Map, Pos),      % meme position
   %maximumWeightSpace(Max),
   %(Dist + DistFly) < (Weight - Max), !.
   %(Dist + DistFly) < Weight, !.
   !.

pathFinding_existInCloseList(Pos, Weight, [ _ | R ])
:- pathFinding_existInCloseList(Pos, Weight, R), !.


pathFinding_existInOpenList(Pos, Weight, [ [Weight2, [_, _, _, _, _, _, Map | _ ]] | _ ])
:- getCurrentCasePosInNavMap(Map, Pos),      % meme position
   %maximumWeightSpace(Max),
   %(Weight2) < (Weight - Max), !.
   %Weight2 < Weight, !.
   !.

pathFinding_existInOpenList(Pos, Weight, [ _ | R ])
:- pathFinding_existInOpenList(Pos, Weight, R), !.


/* ------------------------------------------------
   supprime les cases de mme coordonnes avec des poids trop importants */

   % pathFinding_deleteInOpenList(Pos, Weight, OpenList, NewOpenList)


% meme position, poid trop important
pathFinding_deleteInOpenList(Pos, Weight, [ [Weight2, [_, _, _, _, _, _, Map | _ ]] | Rest ], NewOpenList)
:- getCurrentCasePosInNavMap(Map, Pos),      % meme position
   maximumWeightSpace(Max),
   (Weight2) > (Weight + Max),
   pathFinding_deleteInOpenList(Pos, Weight, Rest, NewOpenList), !.


% on ne retire pas la case
pathFinding_deleteInOpenList(Pos, Weight, [ T | Rest ], [ T | NewRest] )
:- pathFinding_deleteInOpenList(Pos, Weight, Rest, NewRest ), !.

% liste vide
pathFinding_deleteInOpenList(_, _, [], [] )
:- !.